# Annotation Studio - Core plugin
This is the state behind the other components.

### Usage
To use the plugin you need to add it as a dependency:
```
$ npm i @annotation-studio/plugin-core --save-dev
```

Then in your code (ES6 in this example)

```jsx harmony
import CorePlugin from '@annotation-studio/plugin-core';

const core = CorePlugin(
  document.getElementById('myContainer'),
  {
    resourceTemplates: '...',
    manifest: '...',
    canvas: '...',
    elucidateServer: '...',
  }
);

core.then(store => {
  // this is called whenever the store changes
  store.subscribe(() => {
    // This is how to get the state
    const state = store.getState();
    // You can now render things, dispatch actions etc.
  })
})
```

### Resource templates:
[todo add link to resource template model]
