var _class, _temp2;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import { connector } from '@annotation-studio/redux';
import { isSavedDraft, changeFingerprintSource, changeFingerprintIdentity, changeFingerPrintCreator } from '@annotation-studio/redux/es/actions/drafts';
import { getAllAnnotationsFromCollection } from '@annotation-studio/redux/es/lib/elucidate/index';
import { asyncForEach } from './core.utils';
import 'whatwg-fetch';

var Core = (_temp2 = _class = function (_Component) {
  _inherits(Core, _Component);

  function Core() {
    var _temp, _this, _ret;

    _classCallCheck(this, Core);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      onlineStatus: Core.ONLINE
    }, _this.setOnline = function () {
      _this.setState({ onlineStatus: Core.ONLINE_NOTIFICATION });
      setTimeout(function () {
        _this.setState({ onlineStatus: Core.ONLINE });
      }, 2000);
    }, _this.setOffline = function () {
      _this.setState({ onlineStatus: Core.OFFLINE });
    }, _this.hasPrompted = false, _this.warnUser = function (event) {
      var _this$props = _this.props,
          drafts = _this$props.drafts,
          disableCloseWarning = _this$props.disableCloseWarning;

      var changes = drafts ? Object.values(drafts).filter(function (draft) {
        return draft.fingerprint.lifecycle === 'DRAFT_LIFECYCLE_CHANGED';
      }) : [];
      var changedValues = Object.values(drafts).map(function (draft) {
        return Object.values(draft.input).filter(function (e) {
          return e;
        });
      }).filter(function (e) {
        return e.length;
      });

      if (!_this.hasPrompted && changes.length && changedValues.length && disableCloseWarning === false) {
        _this.hasPrompted = true;
        var message = 'You have ' + changes + ' unsaved annotation' + (changes.length > 1 ? 's' : null) + ', if you leave the page they will be lost.';
        event.preventDefault();
        event.returnValue = message;
        return message;
      }
      return null;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Core.prototype.componentDidMount = function componentDidMount() {
    var _props = this.props,
        setServer = _props.setServer,
        canvasId = _props.canvas,
        manifest = _props.manifest,
        createCollection = _props.createCollection,
        addElucidateAnnotation = _props.addElucidateAnnotation,
        setResource = _props.setResource,
        elucidateServer = _props.elucidateServer,
        addManifest = _props.addManifest,
        selectManifest = _props.selectManifest,
        selectCanvas = _props.selectCanvas,
        importDraft = _props.importDraft,
        savedDraftList = _props.savedDraftList;


    var subject = canvasId ? canvasId : manifest;

    if (!elucidateServer) {
      return;
    }
    if (canvasId) {
      fetch(manifest).then(function (response) {
        return response.json();
      }).then(function (response) {
        return addManifest(manifest, response);
      }).then(function (response) {
        return selectManifest(manifest);
      }).then(function (response) {
        return canvasId ? selectCanvas(canvasId) : null;
      });
    }
    // Set the server.
    setServer(elucidateServer, subject);
    // Set the resource.
    if (subject) {
      setResource(subject);
    }

    window.addEventListener('online', this.setOnline);
    window.addEventListener('offline', this.setOffline);
    window.addEventListener('beforeunload', this.warnUser);

    this.setState({
      onlineStatus: navigator.onLine ? Core.ONLINE : Core.OFFLINE
    });

    // Import local storage saved items
    if (savedDraftList && Object.keys(savedDraftList).length) {
      Object.values(savedDraftList).forEach(function (drafts) {
        return Object.values(drafts).forEach(function (draft) {
          importDraft(draft.id, changeFingerPrintCreator(draft, 'you'));
        });
      });
    }

    // Set collection.
    createCollection(subject, subject).then(function (c) {
      return getAllAnnotationsFromCollection(c);
    }).then(function (iterable) {
      return asyncForEach(iterable, function (i) {
        if (isSavedDraft(i)) {
          var draft = JSON.parse(i.body.value);
          var identity = i.id.substr(i.id.length - 1) === '/' ? i.id.substr(0, i.id.length - 1).split('/').pop() : i.id.split('/').pop();
          if (draft) {
            importDraft(draft.id, changeFingerPrintCreator(changeFingerprintIdentity(draft, identity), i.creator && i.creator.name ? i.creator.name : 'unknown'));
          }
        } else {
          addElucidateAnnotation(i);
        }
      });
    });
  };

  Core.prototype.renderOffline = function renderOffline() {
    var drafts = this.props.drafts;

    var changes = drafts ? Object.values(drafts).filter(function (draft) {
      return draft.fingerprint.lifecycle === 'DRAFT_LIFECYCLE_CHANGED';
    }) : [];
    return React.createElement(
      'div',
      { className: 'offline-notice' },
      'This page is currently offline. ',
      ' ',
      changes.length ? React.createElement(
        'span',
        null,
        'If you leave this page you may lose your progress on',
        ' ',
        changes.length,
        ' annotation',
        changes.length > 1 ? 's' : null
      ) : null
    );
  };

  Core.prototype.renderOnline = function renderOnline() {
    return React.createElement(
      'div',
      { className: 'online-notice' },
      'Internet connection restored'
    );
  };

  Core.prototype.render = function render() {
    var children = this.props.children;
    var onlineStatus = this.state.onlineStatus;


    return React.createElement(
      'div',
      null,
      onlineStatus === Core.OFFLINE ? this.renderOffline() : null,
      onlineStatus === Core.ONLINE_NOTIFICATION ? this.renderOnline() : null,
      React.createElement(
        'span',
        { style: { display: 'none' } },
        'Annotation studio is running on this page. React ',
        React.version
      ),
      children
    );
  };

  return Core;
}(Component), _class.ONLINE = 0, _class.ONLINE_NOTIFICATION = 1, _class.OFFLINE = 2, _temp2);


export default connector(Core);