function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import { render } from 'react-dom';
import { unknownPropertyWarning } from './core.utils';
import CoreProvider from './core.provider';

export default function CorePlugin($el, _ref) {
  var manifest = _ref.manifest,
      canvas = _ref.canvas,
      elucidateServer = _ref.elucidateServer,
      disableCloseWarning = _ref.disableCloseWarning,
      locale = _ref.locale,
      externalLocaleConfig = _ref.externalLocaleConfig,
      unknownProps = _objectWithoutProperties(_ref, ['manifest', 'canvas', 'elucidateServer', 'disableCloseWarning', 'locale', 'externalLocaleConfig']);

  unknownPropertyWarning(unknownProps);
  var disableCloseWarningBoolean = disableCloseWarning ? disableCloseWarning === 'true' : false;

  return new Promise(function (resolve, err) {
    try {
      render(React.createElement(CoreProvider, {
        locale: locale,
        manifest: manifest,
        disableCloseWarning: disableCloseWarningBoolean,
        elucidateServer: elucidateServer,
        canvas: canvas,
        externalLocaleConfig: externalLocaleConfig,
        onLoadStore: resolve
      }), $el);
    } catch (e) {
      err(e);
    }
  });
}