import _regeneratorRuntime from 'babel-runtime/regenerator';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PureComponent } from 'react';
import { pluginKit } from '@annotation-studio/components';
import { createStore, reducers } from '@annotation-studio/redux';
import localstorage from 'store';
import Core from './core';
import moment from 'moment/moment';

export var DEFAULT_LOCALE = 'en';

var CoreProvider = function (_PureComponent) {
  _inherits(CoreProvider, _PureComponent);

  function CoreProvider() {
    var _temp, _this, _ret;

    _classCallCheck(this, CoreProvider);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.state = {
      savedDraftList: {},
      storeReady: false
    }, _this.store = null, _temp), _possibleConstructorReturn(_this, _ret);
  }

  CoreProvider.prototype.componentWillMount = function componentWillMount() {
    var _this2 = this;

    var _props = this.props,
        locale = _props.locale,
        loadSavedDrafts = _props.loadSavedDrafts,
        savedDraftsId = _props.savedDraftsId,
        savedDraftList = _props.savedDraftList,
        customCreateStore = _props.customCreateStore,
        onLoadStore = _props.onLoadStore;


    var selectedLocale = locale || DEFAULT_LOCALE;

    moment.locale(selectedLocale);

    this.setState({ locale: selectedLocale });

    if (savedDraftList) {
      this.setState({ savedDraftList: savedDraftList });
    }

    if (loadSavedDrafts) {
      var url = savedDraftsId || window.location.href;
      var savedDraftListFromLS = localstorage.get('annotation-studio/' + url) || {};

      this.setState({
        savedDraftList: _extends({}, this.state.savedDraftList, savedDraftListFromLS)
      });
    }

    this.fetchExternalLocaleConfig().then(function (externalLocaleConfig) {
      _this2.store = customCreateStore ? customCreateStore({
        createStore: createStore,
        reducers: reducers,
        locale: _this2.state.locale,
        externalLocale: externalLocaleConfig
      }) : createStore(reducers, [], selectedLocale, externalLocaleConfig);

      if (onLoadStore) {
        onLoadStore(_this2.store);
        _this2.setState({ storeReady: true });
      }
    });
  };

  CoreProvider.prototype.fetchExternalLocaleConfig = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var externalLocaleConfig;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              externalLocaleConfig = this.props.externalLocaleConfig;

              if (externalLocaleConfig) {
                _context.next = 3;
                break;
              }

              return _context.abrupt('return');

            case 3:
              _context.prev = 3;
              return _context.abrupt('return', fetch(externalLocaleConfig).then(function (r) {
                return r.json();
              }));

            case 7:
              _context.prev = 7;
              _context.t0 = _context['catch'](3);

            case 9:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this, [[3, 7]]);
    }));

    function fetchExternalLocaleConfig() {
      return _ref.apply(this, arguments);
    }

    return fetchExternalLocaleConfig;
  }();

  CoreProvider.prototype.getStore = function getStore() {
    return this.store;
  };

  CoreProvider.prototype.render = function render() {
    var _state = this.state,
        storeReady = _state.storeReady,
        savedDraftList = _state.savedDraftList,
        locale = _state.locale;

    var _props2 = this.props,
        plugins = _props2.plugins,
        behaviours = _props2.behaviours,
        children = _props2.children,
        props = _objectWithoutProperties(_props2, ['plugins', 'behaviours', 'children']);

    if (!storeReady) {
      return null;
    }

    return React.createElement(
      pluginKit.Provider,
      {
        store: this.store,
        plugins: plugins,
        behaviours: behaviours
      },
      React.createElement(
        Core,
        _extends({}, props, { savedDraftList: savedDraftList, locale: locale }),
        storeReady && children ? children(_extends({}, props, {
          store: this.store,
          plugins: plugins,
          behaviours: behaviours,
          locale: locale
        })) : null
      )
    );
  };

  return CoreProvider;
}(PureComponent);

export default CoreProvider;