'use strict';

exports.__esModule = true;
exports.fetchResourceTemplate = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var fetchResourceTemplate = exports.fetchResourceTemplate = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee(resource) {
    var headers, locale;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            headers = new Headers();
            locale = _moment2.default.locale();


            if (locale && process.env.NODE_ENV === 'production') {
              headers.set('X-Annotation-Studio-Locale', locale);
            }

            _context.prev = 3;
            _context.next = 6;
            return fetch('' + resource, {
              credentials: 'include',
              headers: headers
            });

          case 6:
            return _context.abrupt('return', _context.sent);

          case 9:
            _context.prev = 9;
            _context.t0 = _context['catch'](3);

            console.warn("Can't send credentials, not same origin. Falling back.");
            _context.prev = 12;
            _context.next = 15;
            return fetch('' + resource, {
              headers: headers
            });

          case 15:
            return _context.abrupt('return', _context.sent);

          case 18:
            _context.prev = 18;
            _context.t1 = _context['catch'](12);

            console.warn('Unable to send locale, likely CORS not available. falling back.');
            _context.next = 23;
            return fetch('' + resource);

          case 23:
            return _context.abrupt('return', _context.sent);

          case 24:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[3, 9], [12, 18]]);
  }));

  return function fetchResourceTemplate(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.getAttributes = getAttributes;
exports.deferred = deferred;
exports.unknownPropertyWarning = unknownPropertyWarning;
exports.connectedBehaviour = connectedBehaviour;
exports.prettyName = prettyName;
exports.renderWhen = renderWhen;
exports.asyncForEach = asyncForEach;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactRedux = require('react-redux');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function getAttributes($el) {
  var attributes = {};
  var length = $el.attributes.length;
  if (length > 0) {
    for (var i = 0; i < length; i++) {
      attributes[prettyName($el.attributes[i].nodeName)] = $el.attributes[i].nodeValue;
    }
  }
  return attributes;
}

function deferred() {
  var resolve = null;
  var promise = new Promise(function (r) {
    resolve = r;
  });
  return { resolve: resolve, promise: promise };
}

function unknownPropertyWarning(unknownProps) {
  delete unknownProps.class;
  delete unknownProps.behaviour;
  delete unknownProps.style;
  if (Object.keys(unknownProps).length) {
    console.warn('Found unknown properties passed to component', unknownProps);
  }
}

function connectedBehaviour($el, store, Component) {
  return (0, _reactDom.render)(_react2.default.createElement(
    _reactRedux.Provider,
    { store: store },
    _react2.default.createElement(Component, null)
  ), $el);
}

function prettyName(attr) {
  if (attr.indexOf('data-') === 0) {
    return attr.substring(5).replace(/-([a-z])/g, function (g) {
      return g[1].toUpperCase();
    });
  }
  return attr;
}

function renderWhen(store, shouldRender, component, root) {
  return new Promise(function (resolve) {
    var subscription = store.subscribe(function () {
      if (shouldRender(store.getState())) {
        resolve((0, _reactDom.render)(component, root));
        subscription();
      }
    });
  });
}

function asyncForEach(iterable, fn) {
  iterable.next().then(function (nextIterate) {
    if (nextIterate.done) {
      return;
    }
    fn(nextIterate.value);
    return asyncForEach(iterable, fn);
  }).catch(function (e) {
    console.warn('asyncForEach: ', e, iterable);
  });
}